unit bezier;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,math,fr_typen;

type doubarray=array of frfloat;

procedure kurven_punkte(np:integer; xb,yb,c:array of frfloat;npi:integer;var xint,yint:doubarray);
procedure Bezier_Koeff(NP:integer;var C:doubarray);

implementation

// Die Kurven-Punkte berechnen und in xint,yint zurückgeben
procedure kurven_punkte(np:integer; xb,yb,c:array of frfloat;npi:integer;var xint,yint:doubarray);
var i,j,k:integer;
    U0,U,F1,F2,XSU,YSU:frfloat;
    DU,X0,Y0:frfloat;
    IE:integer;
    M:integer;
begin
 //*****************************************************************
 //	NP  = Anzahl der Bezier Stuetzpunkte fuer das Polygon         *
 //	NPI = Anzahl der Intervalle zwischen [0,1]                    *
 //  IE  = NPI + 1 Anzahl der interpolierten Zwischenpunkte        *
 //*****************************************************************

 // INTERPOLIEREN DER ZWISCHENWERTE ZWISCHEN U=[0/1] IN AEQUIDISTANTEN
 // ABSTAENDEN DU = 1/(NP-1)

 setlength(xint,npi+1);
 setlength(yint,npi+1);

 U0:=0;
 DU:=1.0/NPi;
 IE:=NPi+1;
 M:=np;

 for i:=1 to ie do
  begin

   J:=I-1;
   U:=U0+(J)*DU;

   // BILDE SUMME X
   X0:=0.0;
   for k:=1 to M do
    begin
     IF K=1
      then F1:=1.0
      ELSE F1:=power(u,k-1);
     IF (I = IE )
      then
       begin
        IF (K = M)
         then F2:=1.0
         ELSE F2:=0.0;
       end
      else
       F2:=power((1-U),(M-K));
     // das ist die ausgeschriebene Summenformel fuer den x-Wert
     // XSU  = X0 + XB(K)*C(K)*(U**(I-1))*((1-U)**(M-I))
     XSU:=X0+XB[K-1]*C[K-1]*F1*F2;
     X0:=XSU;
    end; // for k
   XINT[I-1]:=XSU;

   // BILDE SUMME Y
   Y0:=0.0;
   for k:=1 to M do
    begin
     IF (K = 1)
      then F1:=1.0
      ELSE F1:=power(U,(K-1));
     IF (I=IE )
      then
       begin
        IF (K=M)
         THEN F2:=1.0
         ELSE F2:=0.0;
       end
      else
       F2:=power((1-U),(M-K));
     // das ist die ausgeschriebene Summenformel fuer den y-Wert
     // YSU  = Y0 + YB(K)*C(K)*(U**(I-1))*((1-U)**(M-I))
     YSU:=Y0 + YB[K-1]*C[K-1]*F1*F2;
     Y0:=YSU;
    end; // for k
   YINT[I-1]:=YSU;
  end; // for i
end;

// Einflußkoeffizieten des Bezier-Abschnittes berechnen
procedure Bezier_Koeff(NP:integer;var C:doubarray);
var i,j:integer;
begin
 setlength(c,np);
 //  BERECHNEN DER WERTE C(i,n) = n! / (i!*(n-i)!)
  for i:=1 to np do
   begin
    C[I-1]:=1.0;
    if (i>1) and (i<np) // Eckpunkte aussparen, da Konturpunkte und kein Bezier
     then
      begin
       for j:=i to np-1 do
        C[I-1]:=C[I-1]*J;
       for j:=1 to np-i do
        C[I-1]:=C[I-1]/J;
      end; // if
   end;
END;


end.

