unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  EasyLazFreeType,
  Classes, SysUtils, FileUtil,
  Forms, Controls, Graphics, Dialogs, Spin, Menus, StdCtrls, ExtCtrls,
  fr_3D_Glyph,
  fr_typen,
  BeRoTriangulation;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button5: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Edit1: TEdit;
    FloatSpinEdit1: TFloatSpinEdit;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    OpenDialog1: TOpenDialog;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure CheckBox1Change(Sender: TObject);
    procedure CheckBox2Change(Sender: TObject);
    procedure FloatSpinEdit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
  private
    FTTFFont:TFreeTypeFont;
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  hauptpfad:string;

  _3D_Glyph:T3D_Glyph;
 const version='Glyph_3d_Viewer V1.1'#13'03.02.2017 Frank Ranis';

implementation

{$R *.lfm}

uses unit2;

{ TForm1 }

// TTF-Freetype-Font erzeugen
procedure TForm1.FormCreate(Sender: TObject);
begin
 label12.Caption:=version;

 hauptpfad := extractfiledir(ParamStr(0)) + DirectorySeparator; // Das wichtigste.
 FTTFFont:=TFreeTypeFont.create;
 FTTFFont.Hinted:=false;
 FTTFFont.Name:=hauptpfad+'FreeSans.ttf';
 caption:=FTTFFont.Name;
 spinedit1.MaxValue:=FTTFFont.GlyphCount-1;
end;

// Glyph-Objekt freigeben
procedure TForm1.FormDestroy(Sender: TObject);
begin
 freeandnil(_3D_Glyph);
end;

// Glyph auf Canvas zeichnen
procedure TForm1.FormPaint(Sender: TObject);
var scalefaktor:frfloat;
    i:integer;
begin
 if _3D_Glyph=nil then exit;

 scalefaktor:=FloatSpinEdit1.Value; // zum Zeichnen auf dem Canvas skalieren

 // Die groben Glyph-Polygone zeichnen
 _3D_Glyph.zeichne_grob_polys(self.Canvas,
                              scalefaktor,
                              100,200,
                              checkbox1.Checked);

 // Die Polygone mit aufgelösten Bezierpunkten zeichnen
 _3D_Glyph.zeichne_fein_polys(self.Canvas,
                              scalefaktor,
                              500,200,
                              checkbox1.Checked);

 // Die 2D-Dreickliste zeichnen
 _3D_Glyph.zeichne_dreiecke_2D(self.Canvas,
                               scalefaktor,
                               900,200,clred,clblue,
                               checkbox2.Checked);
end;

// Beim Anzeigen der Form
procedure TForm1.FormShow(Sender: TObject);
begin
 button3.Click;
 self.Invalidate;
end;

// Font auswählen
procedure TForm1.Button1Click(Sender: TObject);
begin
 opendialog1.InitialDir:=hauptpfad;
 opendialog1.Filter:='*.ttf';
 if opendialog1.Execute
  then
   FTTFFont.Name:=opendialog1.FileName
  else
   FTTFFont.Name:=hauptpfad+'FreeSans.ttf';

 caption:=FTTFFont.Name;
 // Brechnen und Zeichnen
 button3.Click;
 invalidate;
end;

// Index eines Uni-Code-Zeichen's finden
procedure TForm1.Button2Click(Sender: TObject);
var s:widestring;
    c:PUniCodeChar;
begin
 s:=edit1.text;
 c:=@s[1];
 spinedit1.Value:=ord(c^);
end;

// Objekt 3D-Glyph erzeugen
procedure TForm1.Button3Click(Sender: TObject);
var glyph:TFreeTypeGlyph;
    z,w,i,j,pp:integer;
    GrobPoly:TGlyph_polygon;
    FeinPoly:TGlyph_polygon;
    punkt,p1,p2:TPolygon_punkt;
    p:punkt3d;
    min,max:punkt3d;

    bero_polys:TBeRoTriangulationPolygons;
    bero_Triangles:TBeRoTriangulationTriangles;
    triangle:TBeRoTriangulationTriangle;

    Points: array of TPoint; // Array für die canvas-Polygonausgabe
    px:tpoint;
    Offset_x,offset_y:integer;
    dreieck,dreieck_neu:tdreieck;
    time1,time2:qword;
    tiefe_z:frfloat;

begin
 freeandnil(_3D_Glyph); // eventuell altes Objekt killen

 // Schritt (1)
 // Das aktuelle Char/Glyph holen , z.B. 65=A
 glyph:=FTTFFont.Glyph[FTTFFont.CharIndex[SpinEdit1.Value]];

 // Objekt 3D-Glyph , mit den Orginal Font-Grobdaten , erzeugen
 _3D_Glyph:=T3D_Glyph.create(glyph); // FTTFFont Glyph übergeben

 // Schritt (2)
 // Startpunkte der Polygone checken
 // Wenn dieser ein Bezierpunkt ist , dann die Pointerliste so lange rotieren,
 // bis der Startpunk der Polgonliste eine Konturpunkt ist
 for i:=0 to _3D_Glyph.Grob_Polys.Count-1 do
  begin
   GrobPoly:=TGlyph_polygon(_3D_Glyph.Grob_Polys[i]);
   // Rotation der Pointerliste
   while TPolygon_punkt(GrobPoly.punkte_liste[0]).kb_eigenschaft=bezierpunkt do
    GrobPoly.rotiere_punkteliste_rechts;
  end;

 // Schritt (3)
 // nun aus den Grob-Polygonen (Bezier_polygonliste) die Bezier-Stützpunkte
 // durch berechnet Konturpunkte ersetzten , Feinauflösung (Glättung)
 // Die berchneten Punkte in einem neuen polygon sammeln und dieses an die Kontur_polygonliste anfügen
 // Das ist dann das schön gemalte Fontbild mit runden Konturen

 for i:=0 to _3D_Glyph.Grob_Polys.Count-1 do
  begin
   // Ein grobes Polygon aus der Bezier_polygonliste holen
   GrobPoly:=TGlyph_polygon(_3D_Glyph.Grob_Polys[i]);
   // Geglättetes Konturpolygon erzeugen
   FeinPoly:=GrobPoly.glaette(spinedit2.value);
   // Die drehrichtung aus dem Bezierpolygon übernehmen
   FeinPoly.Drehrichtung:=GrobPoly.Drehrichtung;
   // Feines Konturpolygon übernehmen
   _3D_Glyph.Fein_Polys.Add(FeinPoly);
  end;

 // Schritt (4)
 // Die Fein_Polys triangulieren
 time1:=GetTickCount64;
 bero_polys:=_3D_Glyph.mach_bero_polys;
 // in die Triangulierungsroutine von BeRo gehen
 // Hier gibt es 3 Möglichkeiten
 case spinedit3.Value of
  1:BeRoTriangulation.TriangulateDelaunayClipping(bero_polys,     // Input Polygonliste
                                                  bero_Triangles, // Output Dreieckliste
                                                  btpfrEVENODD);
  2:BeRoTriangulation.TriangulateBeRo(bero_polys,      // Input Polygonliste
                                      bero_Triangles); // Output Dreieckliste

  3:BeRoTriangulation.TriangulateSeidel(bero_polys,      // Input Polygonliste
                                        bero_Triangles); // Output Dreieckliste
 end;

 time2:=GetTickCount64;
 label10.Caption:='Anzahl Dreiecke='+inttostr(length(bero_Triangles));
 label11.Caption:='Laufzeit[ms] der Triangulierung='+inttostr(time2-time1);
 label10.Update;
 label11.Update;

 // Die Dreiecke BeRo-Dreiecke in die 2D-Dreieckliste des _3D_Glyph-Objektes übertragen
 for i:=0 to length(bero_Triangles)-1 do
  begin
   triangle:=TBeRoTriangulationTriangle(bero_Triangles[i]);
   dreieck:=tdreieck.Create;
   dreieck.a.x:=triangle[0].x;
   dreieck.a.y:=triangle[0].y;
   dreieck.a.z:=0;
   dreieck.b.x:=triangle[1].x;
   dreieck.b.y:=triangle[1].y;
   dreieck.b.z:=0;
   dreieck.c.x:=triangle[2].x;
   dreieck.c.y:=triangle[2].y;
   dreieck.c.z:=0;

   // Normalvektor berechnen
   dreieck.berechne_normalvektor;
   // wenn der Normmalvektor nch hinten zeigt
   // Zwei Dreieckpunkte tauschen
   if dreieck.nv.z<0
    then
     begin
      p:=dreieck.A;
      dreieck.a:=dreieck.B;
      dreieck.B:=p;
      dreieck.berechne_normalvektor;
     end;

   _3D_Glyph.Dreiecklist2D.Add(dreieck);
  end;

 // Schritt (5)
 // zum 3D-Körper Extrudieren in die 3D-Dreieckliste eintragen Z-Koordinate=tiefe_z
 tiefe_z:=500;
 for i:=0 to _3D_Glyph.Dreiecklist2D.Count-1 do
  begin
   dreieck:=tdreieck(_3D_Glyph.Dreiecklist2D[i]); // ein Dreieck aus der 2D-Liste

   // Kopie des Deckels bauen
   dreieck_neu:=tdreieck.Create;
   // Koordinaten kopieren , dabei zwei Punkt tauschen, wegen der Normalvektorberechneung
   dreieck_neu.A:=dreieck.A;
   dreieck_neu.B:=dreieck.B;
   dreieck_neu.C:=dreieck.C;
   dreieck_neu.berechne_normalvektor;
   _3D_Glyph.Dreiecklist3D.Add(dreieck_neu);

   // Kopie bauen für das Hinterteil
   dreieck_neu:=tdreieck.Create;
   // Koordinaten kopieren , dabei zwei Punkt tauschen, wegen der Normalvektorberechneung
   dreieck_neu.A:=dreieck.B;
   dreieck_neu.A.z:=tiefe_z;

   dreieck_neu.B:=dreieck.A;
   dreieck_neu.B.z:=tiefe_z;

   dreieck_neu.C:=dreieck.C;
   dreieck_neu.C.z:=tiefe_z;

   dreieck_neu.berechne_normalvektor;
   _3D_Glyph.Dreiecklist3D.Add(dreieck_neu);
  end;
 // nun mit Hilfe der Feinpolygonlisten die Seitenteile konstruieren
 for i:=0 to _3D_Glyph.Fein_Polys.Count-1 do
  begin
   FeinPoly:=TGlyph_polygon(_3D_Glyph.Fein_Polys[i]);
   for j:=0 to FeinPoly.punkte_liste.Count-1 do
    begin
     p1:=TPolygon_punkt(FeinPoly.punkte_liste[j]);
     if j<FeinPoly.punkte_liste.Count-1
     then
      p2:=TPolygon_punkt(FeinPoly.punkte_liste[j+1])
     else
      p2:=TPolygon_punkt(FeinPoly.punkte_liste[0]);

     // nun immer zwei neue Dreiecke für die Seitenteile bauen
     dreieck_neu:=tdreieck.Create;
     dreieck_neu.A.x:=p1.x;
     dreieck_neu.A.y:=p1.y;
     dreieck_neu.A.z:=0;
     dreieck_neu.B.x:=p2.x;
     dreieck_neu.B.y:=p2.y;
     dreieck_neu.B.z:=0;
     dreieck_neu.C.x:=p1.x;
     dreieck_neu.C.y:=p1.y;
     dreieck_neu.C.z:=tiefe_z;
     dreieck_neu.berechne_normalvektor;
     _3D_Glyph.Dreiecklist3D.Add(dreieck_neu);
     dreieck_neu:=tdreieck.Create;
     dreieck_neu.A.x:=p2.x;
     dreieck_neu.A.y:=p2.y;
     dreieck_neu.A.z:=0;
     dreieck_neu.B.x:=p2.x;
     dreieck_neu.B.y:=p2.y;
     dreieck_neu.B.z:=tiefe_z;
     dreieck_neu.C.x:=p1.x;
     dreieck_neu.C.y:=p1.y;
     dreieck_neu.C.z:=tiefe_z;
     dreieck_neu.berechne_normalvektor;
     _3D_Glyph.Dreiecklist3D.Add(dreieck_neu);
    end;
  end;

 // Alles zeichnen
 self.Invalidate;
 if form2.Visible
  then
   form2.OpenGLControl1.Invalidate;
end;

// 3D-Grafik-Fenster öffnen
procedure TForm1.Button5Click(Sender: TObject);
begin
 form2.Show;
end;

// Punkte darstellen
procedure TForm1.CheckBox1Change(Sender: TObject);
begin
 Invalidate;
end;

// Kanten der Triangulierungs-Dreiecke
procedure TForm1.CheckBox2Change(Sender: TObject);
begin
 Invalidate;
end;

// Neuer Scalefaktor
procedure TForm1.FloatSpinEdit1Change(Sender: TObject);
begin
 Invalidate;
end;

// Neuer Glyph gewählt
procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
 // alles neu
 button3.Click;
 self.Invalidate;
end;

// Bezier-Auflösung geändert
procedure TForm1.SpinEdit2Change(Sender: TObject);
begin
 // alles neu
 button3.Click;
 self.Invalidate;
end;

// Triangulierungs-Verfahren geändert
procedure TForm1.SpinEdit3Change(Sender: TObject);
begin
 // alles neu
 button3.Click;
 self.Invalidate;
end;

end.

