unit unit2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, ComCtrls, Spin, OpenGLContext, dglOpenGL, fr_3D_Glyph, fr_typen,
  Types;

type

  { TForm2 }

  TForm2 = class(TForm)
    FloatSpinEdit1: TFloatSpinEdit;
    Label1: TLabel;
    ToolBar1: TToolBar;
    procedure FloatSpinEdit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormPaint(Sender: TObject);
  private
    { private declarations }
  public
    OpenGLControl1: TOpenGLControl;
  end;

var
 Form2: TForm2;

 position3d:punkt3d;
 Mausstart_3Dx:Integer;
 Mausstart_3Dy:Integer;

 winkel_um:punkt3d;

const Perspective_winkel=20;

var
    glfLightModelAmbient: Array[0..3] of TGLfloat =(0.2,0.2,0.2,1.0);
    // Lichtposition
    glfLight0Position: array[0..3] of glFloat = (0.0, 5.0, 20.0, 1.0); // Position for Light0
//    glfLight0Position: Array[0..3] of TGLfloat = (50,0,100,1);
    glfLight1Position: Array[0..3] of TGLfloat = (-50,0,100,1);
    glfLight0Direction: Array[0..3] of TGLfloat = (-50,0,-100,1);
    glfLight1Direction: Array[0..3] of TGLfloat = (50,0,-100,1);

    glfLightAmbient  : array[0..3] of TGLfloat = (0.2, 0.2, 0.2, 1.0); // Ambient setting for light0
    gLflightDiffuse  : array[0..3] of TGLfloat = (1.0, 1.0, 1.0, 1.0); // Diffuse setting for Light0
    gLflightSpecular : array[0..3] of TGLfloat = (0.8, 0.8, 0.8, 1.0); // Specular lighting for Light0
//    glfLightAmbient  : Array[0..3] of TGLfloat = (0.8,0.8,0.8,1);
//    glfLightDiffuse  : Array[0..3] of TGLfloat = (1,1,1,1);
//    glfLightSpecular : Array[0..3] of TGLfloat = (0.8,0.8,0.8,1);

//glfMatrialAmbient : Array[0..3] of TGLfloat = (0.8, 0.8, 0.8, 1.0);
    glfMatrialAmbient : Array[0..3] of TGLfloat = (1.0, 1.0, 1.0, 1.0);
    glfMatrialDiffuse : Array[0..3] of TGLfloat = (0.8, 0.8, 0.8, 1.0);
//    glfMatrialSpecular: Array[0..3] of TGLfloat = (0.5, 0.5, 0.5, 1.0);
    glfMatrialSpecular: Array[0..3] of TGLfloat = (0.5, 0.5, 0.5, 1.0);
    glfMatrialShine:  TGLfloat = 10;

procedure InitializeLight0;
procedure InitializeLight1;
procedure InitializeMaterial;

implementation

{$R *.lfm}

uses Unit1;

{ TForm2 }

// Lichteigenschaften 0 einstellen
procedure InitializeLight0;
begin
  glMatrixMode(GL_MODELVIEW);
//  glLoadIdentity;
  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_POSITION ,@glfLight0Position);
//  glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, @glfLight0Direction);
  glLightfv(GL_LIGHT0, GL_AMBIENT,  @glfLightAmbient);
  glLightfv(GL_LIGHT0, GL_DIFFUSE,  @glfLightDiffuse);
  glLightfv(GL_LIGHT0, GL_SPECULAR, @glfLightSpecular);
end;

// Lichteigenschaften 1 einstellen
procedure InitializeLight1;
begin
  glMatrixMode(GL_MODELVIEW);
//  glLoadIdentity;
  glEnable(GL_LIGHT1);
  glLightfv(GL_LIGHT1, GL_POSITION ,@glfLight1Position);
//  glLightfv(GL_LIGHT1, GL_SPOT_DIRECTION, @glfLight1Direction);
  glLightfv(GL_LIGHT1, GL_AMBIENT,  @glfLightAmbient);
  glLightfv(GL_LIGHT1, GL_DIFFUSE,  @glfLightDiffuse);
  glLightfv(GL_LIGHT1, GL_SPECULAR, @glfLightSpecular);
end;


// Materialeigenschaften einstellen
procedure InitializeMaterial;
begin
  glMaterialfv(GL_FRONT_and_back, GL_AMBIENT,   @glfMatrialAmbient);
  glMaterialfv(GL_FRONT_and_back, GL_DIFFUSE,   @glfMatrialDiffuse);
  glMaterialfv(GL_FRONT_and_back, GL_SPECULAR,  @glfMatrialSpecular);
  glMaterialf (GL_FRONT_and_back, GL_SHININESS, glfMatrialShine);
end;


// OpenGl-Szene initalisieren
procedure TForm2.FormCreate(Sender: TObject);
begin
 winkel_um.x:=10;
 winkel_um.y:=20;
 winkel_um.z:=0;
 position3d.x:=0;
 position3d.y:=0;
 position3d.z:=-20;

 OpenGLControl1:=TOpenGLControl.Create(Self);
 OpenGLControl1.Name:='OpenGLControl1';
 OpenGLControl1.Align:=alClient;
 OpenGLControl1.Parent:=self;
 OpenGLControl1.OnPaint:=@FormPaint;
 OpenGLControl1.AutoResizeViewport:=true;
 OpenGLControl1.OnMouseMove:=@formMouseMove;
 OpenGLControl1.OnMouseDown:=@FormMouseDown;
 OpenGLControl1.OnMouseWheelDown:=@FormMouseWheelDown;
 OpenGLControl1.OnMouseWheelUp:=@FormMouseWheelUp;

 { Beginn: Initialisierung von OpenGL bei Verwendung der dglOpenGL}
 InitOpenGL;
 OpenGLControl1.MakeCurrent;
 ReadExtensions;
 ReadImplementationProperties;

 OpenGLControl1.DoubleBuffered:=true;
 { End: Initialisierung von OpenGL bei Verwendung der dglOpenGL}

 { Beginn: Initialisierung von OpenGL gemäß Neon Helium}
 glShadeModel(GL_SMOOTH);             // Enables Shmooth Shading
 glClearColor(0.0, 0.0, 0.0, 0.5);    // Black Background
 glClearDepth(1.0);                   // Depth Buffer Setup
 glEnable(GL_DEPTH_TEST);             // Enables Depth Testing
 glDepthFunc(GL_LEQUAL);              // The Type of Depth Test to Do
 glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST); // Really Nice Perspective Calculations
 { End: Initialisierung von OpenGL gemäß Neon Helium}

 // Lichtmodus einschalten
 glEnable(GL_LIGHTING);
 // Material-Farben-modus einschalten
 glEnable(GL_COLOR_MATERIAL);
 glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, 0);
 // Licht soll auf beiden Seiten einer Fläche wirksam sein
 glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, 1);
 // Lichtmodell aktivieren
 glLightModelfv(GL_LIGHT_MODEL_AMBIENT, @glfLightModelAmbient);
 // Licht einstellen und positionieren
 InitializeLight0;
// InitializeLight1;
 // Material-Eigenschalten einstellen
 InitializeMaterial;

end;

// Scalefaktor
procedure TForm2.FloatSpinEdit1Change(Sender: TObject);
begin
 // neu zeichnen
 OpenGLControl1.Invalidate;
end;

// Startpunkt für Schieben und Rotieren
procedure TForm2.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 // Mauspunkte merken
 Mausstart_3Dx:=x;
 Mausstart_3Dy:=y;
end;

// Rotieren und Verschieben
procedure TForm2.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var diff_x,diff_y,diff_z:double;
begin

 // rotieren um die X- und Y-Achse
 // linke Maustaste gedrückt
 if (ssleft in shift) and (not (ssRight in shift))
  then
   begin
    // Rotation um die X-Achse
    diff_y:=(y-Mausstart_3Dy);
    winkel_um.x:=
     winkel_um.x+diff_y;
    if winkel_um.x > 359 then
     winkel_um.x:=0;
    if winkel_um.x < 0 then
     winkel_um.x:=359;
    mausstart_3Dy:=y;
    // Rotation um die Y-Achse
    diff_x:=(x-Mausstart_3Dx);
    winkel_um.y:=
     winkel_um.y+diff_x;
    if winkel_um.y > 359 then
     winkel_um.y:=0;
    if winkel_um.y < 0 then
     winkel_um.y:=359;
    mausstart_3Dx:=x;
    // neu zeichnen
    OpenGLControl1.Invalidate;
   end;

 // verschieben in X- und Y-Achse
 // rechte Maustaste gedrückt
 if (ssRight in shift) and (not (ssleft in shift))
  then
    begin
     // Verschieben in der X-Achse
     diff_x:=(x-Mausstart_3Dx)/20;
     Position3d.x:=Position3d.x+diff_x;
     mausstart_3Dx:=x;
     // Verschieben in der Y-Achse
     diff_y:=(y-Mausstart_3Dy)/20;
     Position3d.y:=Position3d.y-diff_y;
     mausstart_3Dy:=y;
     // neu zeichnen
     OpenGLControl1.Invalidate;
    end;
end;

// Zoom
procedure TForm2.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
 Position3d.z:=Position3d.z+3;
 // neu zeichnen
 OpenGLControl1.Invalidate;
end;

// Zoom
procedure TForm2.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
 Position3d.z:=Position3d.z-3;
 // neu zeichnen
 OpenGLControl1.Invalidate;
end;

// OpenGL - Painting
procedure TForm2.FormPaint(Sender: TObject);
var i:integer;
    dreieck:tdreieck;
const fak=100;
begin
 // Hintergrund mit Farbe löschen
 glClearColor(0.8, 0.8, 0.8, 1.0);
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

 glEnable(GL_DEPTH_TEST);

 // Projektionsmodus
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity();
 gluPerspective(45, frfloat(OpenGLControl1.Parent.width) / OpenGLControl1.Parent.height, 0.01, 500.0);

 // Modellmodus
 glMatrixMode(GL_MODELVIEW);
 glLoadIdentity();

 glTranslatef(position3d.x,position3d.y,position3d.z);
 glRotatef(winkel_um.x,1,0,0); // um X-Achse
 glRotatef(winkel_um.y,0,1,0); // um Y-Achse
 glRotatef(winkel_um.z,0,0,1); // um Z-Achse

 glscalef(1,1,floatspinedit1.Value);

 // 3D-Liste zeichnen
 for i:=0 to _3D_Glyph.Dreiecklist3D.Count-1 do
 begin
  dreieck:=Tdreieck(_3D_Glyph.Dreiecklist3D[i]);
  glNormal3f(dreieck.nv.x,
             dreieck.nv.y,
             dreieck.nv.z);
  glBegin(GL_polygon);
   glColor3f(0.0,0.0,0.8);
   glVertex3f(dreieck.A.x/fak,dreieck.A.y/fak,dreieck.A.z/fak);
   glVertex3f(dreieck.b.x/fak,dreieck.b.y/fak,dreieck.b.z/fak);
   glVertex3f(dreieck.c.x/fak,dreieck.c.y/fak,dreieck.c.z/fak);
  glEnd();
 end;

 OpenGLControl1.SwapBuffers;
end;

end.

